--------------------------------------------------------------------------------
-- Company: <Name>
--
-- File: clock_div.vhd
-- File history:
--      <Revision number>: <Date>: <Comments>
--      <Revision number>: <Date>: <Comments>
--      <Revision number>: <Date>: <Comments>
--
-- Description: 
--
-- <Description here>
--
-- Targeted device: <Family::PolarFire> <Die::MPF300T_ES> <Package::FCG1152>
-- Author: <Name>
--
--------------------------------------------------------------------------------

library IEEE;

use IEEE.std_logic_1164.all;
use IEEE.STD_LOGIC_arith.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

entity clock_div is
port (
    nReset  : in  std_logic;
    clk_in  : in  std_logic;
    clk_out : out std_logic
);
end clock_div;
architecture architecture_clock_div of clock_div is

    signal   clk_out_i : std_logic;

    signal   cntr     : std_logic_vector(5 downto 0);
    constant cntr_max : std_logic_vector(5 downto 0) := conv_std_logic_vector(50-1, 6);

begin

    cntP : process(clk_in, nReset)
    begin
        if(nReset = '0') then
            cntr <= (others => '0');
        elsif(clk_in'event and clk_in = '1') then
            if(cntr = cntr_max) then
                cntr <= (others => '0');
                clk_out_i <= not clk_out_i;
            else
                cntr <= cntr + 1;
            end if;
        end if;
    end process cntP;

    clk_out <= clk_out_i;

end architecture_clock_div;
